//+-----------------------------------------------------------------+
//+           Spearman,Rosh Bookkeeper, 2007, yuzefovich@gmail.com  +
//+           Leledc:added MaBuffer,alerts                          +
//+                                                                 +
//+-----------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  Yellow
#property indicator_color2  SteelBlue
#property indicator_color3  SteelBlue
#property indicator_color4  Coral
#property indicator_color5  Coral
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2

#property indicator_width6 1
#property indicator_maximum 1.1
#property indicator_minimum -1.1
#property indicator_level1 0.95
#property indicator_level2 -0.95
#property indicator_level3 0
#property strict 

//---- input parameters
//---- Snake 
extern int    SnakeRange   = 36; 
extern int    FilterPeriod = 30; 
extern double MartFiltr    = 2;
extern int    PriceConst   = 6; 
extern int    Countbars    = 500;

//---- buffers
double SRCBuffer[];
double Axis[];
double Mart[];
double Upa[],Upb[],Downa[],Downb[],slope[];

//---- SpearmanRankCorrelation
int    rangeN = 14; //   = 30 maximum
double R2[];
double multiply;
int    PriceInt[];
int    SortInt[];
bool TurnedUp = false;
bool TurnedDown = false;

int init() { 

IndicatorDigits((int)MarketInfo(Symbol(), MODE_DIGITS));

IndicatorBuffers(8);
SetIndexBuffer(0,SRCBuffer);
SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(1,Upa);
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(2,Upb);
SetIndexStyle(2,DRAW_LINE);
SetIndexBuffer(3,Downa);
SetIndexStyle(3,DRAW_LINE);
SetIndexBuffer(4,Downb);
SetIndexStyle(4,DRAW_LINE);
SetIndexBuffer(5,Axis);
SetIndexStyle(5,DRAW_NONE);
SetIndexBuffer(6,Mart);
SetIndexStyle(6,DRAW_NONE);
SetIndexBuffer(7,slope);
SetIndexStyle(7,DRAW_NONE);

ArrayResize(R2,rangeN);
ArrayResize(PriceInt,rangeN);
ArrayResize(SortInt,rangeN);
IndicatorShortName(WindowExpertName()+"( SR:"+(string)SnakeRange+", FP:"+(string)FilterPeriod+" )");
multiply = MathPow(10, Digits);

return(0); 

}
//+------------------------------------------------------------------+
int deinit() { 
return(0);
 }
//+------------------------------------------------------------------+
int start() {

   SetIndexDrawBegin(0,Bars-Countbars);
   SetIndexDrawBegin(1,Bars-Countbars);
   SetIndexDrawBegin(2,Bars-Countbars);
   SetIndexDrawBegin(3,Bars-Countbars);
   SetIndexDrawBegin(4,Bars-Countbars);
 
int i,k,limit=MathMin(Countbars,Bars-1);
int LastSignal=0;
 int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);

   if (slope[limit] ==  1) ClearPoint(limit,Upa,Upb);
   if (slope[limit] == -1) ClearPoint(limit,Downa,Downb);
   for(i=0;i<limit;i++) MartAxis(i);
   for(i=0;i<limit;i++) SmoothOverMart(i);
   for(i=0;i<limit;i++)
   { 
      for(k=0;k<rangeN;k++)
         PriceInt[k] = (int)MathRound(Mart[i+k]*multiply);
         RankPrices(PriceInt);
         SRCBuffer[i]=SpearmanRankCorrelation(R2,rangeN);
            if(SRCBuffer[i]>1.0)  SRCBuffer[i]= 1.0; 
            if(SRCBuffer[i]<-1.0) SRCBuffer[i]=-1.0;
   }

   for (i =limit;i >=0; i--)
   {
      slope[i] = slope[i+1];
         if ( SRCBuffer[i]> SRCBuffer[i+1]) slope[i] =  1;
         if ( SRCBuffer[i]< SRCBuffer[i+1]) slope[i] = -1;
         Upa[i]   = EMPTY_VALUE;
         Upb[i]   = EMPTY_VALUE;
         Downa[i] = EMPTY_VALUE;
         Downb[i] = EMPTY_VALUE;
         if (slope[i] ==  1) PlotPoint(i,Upa  ,Upb  ,SRCBuffer);
         if (slope[i] == -1) PlotPoint(i,Downa,Downb,SRCBuffer);
   }
   return(0);
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void MartAxis(int Pos) { int SnakeWeight,i,w,ww,Shift;double SnakeSum;
switch(PriceConst) {
case  0: 
  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_CLOSE,Pos);
  break;
case  1: 
  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_OPEN,Pos);
  break;
case  2: 
  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_HIGH,Pos);
  break;
case  3: 
  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_LOW,Pos);
  break;
case  4: 
  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_MEDIAN,Pos);
  break;
case  5: 
  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_TYPICAL,Pos);
  break;
case  6: 
  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_WEIGHTED,Pos);
  break;
default: 
  Axis[Pos]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_WEIGHTED,Pos);
  break; }
for(Shift=Pos+SnakeRange+2;Shift>Pos;Shift--) { SnakeSum=0.0;
SnakeWeight=0; i=0; w=Shift+SnakeRange; ww=Shift-SnakeRange;
if(ww<Pos) ww=Pos;
while(w>=Shift) { i++; SnakeSum=SnakeSum+i*SnakePrice(w); 
SnakeWeight=SnakeWeight+i; w--; }
while(w>=ww) { i--; SnakeSum=SnakeSum+i*SnakePrice(w);
SnakeWeight=SnakeWeight+i; w--; }
Axis[Shift]=SnakeSum/SnakeWeight; } return; }
//----
double SnakePrice(int Shift) {
switch(PriceConst) {
   case  0: return(Close[Shift]);
   case  1: return(Open[Shift]);
   case  2: return(High[Shift]);
   case  3: return(Low[Shift]);
   case  4: return((High[Shift]+Low[Shift])/2);
   case  5: return((Close[Shift]+High[Shift]+Low[Shift])/3);
   case  6: return((2*Close[Shift]+High[Shift]+Low[Shift])/4);
   default: return(Close[Shift]); } }
//+------------------------------------------------------------------+
void SmoothOverMart(int Shift) { double t,b;
t=Axis[ArrayMaximum(Axis,FilterPeriod,Shift)];
b=Axis[ArrayMinimum(Axis,FilterPeriod,Shift)];
Mart[Shift]=(2*(2+MartFiltr)*Axis[Shift]-(t+b))/2/(1+MartFiltr);
return; }
//+------------------------------------------------------------------+
//| calculate  RSP  function                                         |
//+------------------------------------------------------------------+
double SpearmanRankCorrelation(double& Ranks[], int N)
  {
//----
   double res,z2;
   int i;
   for(i = 0; i < N; i++)
     {
       z2 += MathPow(Ranks[i] - i - 1, 2);
     }
   res = 1 - 6*z2 / (MathPow(N,3) - N);
//----
   return(res);
  }
//+------------------------------------------------------------------+
//| Ranking array of prices function                                 |
//+------------------------------------------------------------------+
void RankPrices(int& InitialArray[])
  {
//----
   int i, k, m, dublicat, counter, etalon;
   double dcounter, averageRank;
   double TrueRanks[];
   ArrayResize(TrueRanks, rangeN);
   ArrayCopy(SortInt, InitialArray);
   for(i = 0; i < rangeN; i++) 
       TrueRanks[i] = i + 1;
  // if(direction)
       ArraySort(SortInt, 0, 0, MODE_DESCEND);
  // else
    //   ArraySort(SortInt, 0, 0, MODE_ASCEND);
   for(i = 0; i < rangeN-1; i++)
     {
       if(SortInt[i] != SortInt[i+1]) 
           continue;
       dublicat = SortInt[i];
       k = i + 1;
       counter = 1;
       averageRank = i + 1;
       while(k < rangeN)
         {
           if(SortInt[k] == dublicat)
             {
               counter++;
               averageRank += k + 1;
               k++;
             }
           else
               break;
         }
       dcounter = counter;
       averageRank = averageRank / dcounter;
       for(m = i; m < k; m++)
           TrueRanks[m] = averageRank;
       i = k;
     }
   for(i = 0; i < rangeN; i++)
     {
       etalon = InitialArray[i];
       k = 0;
       while(k < rangeN)
         {
           if(etalon == SortInt[k])
             {
               R2[i] = TrueRanks[k];
               break;
             }
           k++;
         }
     }
//----
   return;
  }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
   {
      if (first[i+2] == EMPTY_VALUE) 
      {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
      }
      else
      {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
      }
   }
   else
   {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

